// Controllo cella di lievitazione
// EVOL AUTOMATION s.r.l.s.
// Frederic Alfano 
// OUT0 LuceInterna, OUT1 Ventilazione, OUT2 Compressore, OUT3 Raffreddamento, OUT4 Sbrinamento, OUT5 Ultrasuoni, OUT6 EV_Acqua, OUT7 Scarico


//Cella di lievitazione by EVOL AUTOMATION s.r.l.s.
//by Frederic Alfano

#include <Arduino_MachineControl.h>
#include "Wire.h"
#include <ArduinoModbus.h>
#include "EthernetInterface.h"
EthernetInterface net;

using namespace machinecontrol;
//----------485--------------------

constexpr unsigned long sendInterval { 1000 };
unsigned long sendNow { 0 };
unsigned long counter = 0;
//---------------------------------

//-------- e_TEMPERATURA ----------
// The value of the Rref resistor. Use 430.0 for PT100 and 4300.0 for PT1000
#define RREF      390.0
// The 'nominal' 0-degrees-C resistance of the sensor
// 100.0 for PT100, 1000.0 for PT1000
#define RNOMINAL  100.0
//---------------------------------

//-------- Variabili MODBUS HMI ----
//Dichiarazione per MODBUS
bool VENTILAZIONE ; //
bool SBRINAMENTO_ON ; //
bool Spegnimento_Attivo ; //Bit di stop dopo che la ricetta è finita
bool FC_PORTA1 ; //
bool FC_PORTA2 ; //
bool COMANDO_LUCE; //Swtich di accensione luce
bool Comulativo_Allarmi ; //Comulativo allarmi
int SP_Temp ; //Set point temperatura - Il dato è in decimi di grado
int SP_Um ; //Set point umidita - Il dato è in decimi di grado
int T_Int ; //temperatura interna
int T_Est ; //temperatura esterna
int Um_Att ; //umidità attuale
int T_Cmp ; //Temperatura compressore 
int FC_Porta_word1 ; //Fine corsa porta in word per il grafico - settarlo a 1 se la porta è aperta 0 se è chiusa
int FC_Porta_word2 ; //Fine corsa porta in word per il grafico - settarlo a 1 se la porta è aperta 0 se è chiusa
int TMin_Cmp ; //Temperatura minima compressore
int TMax_Cmp ; //Temperatura massima compressore
bool FC_Luce ; //
bool Delay_Start ; //Accensione modalità timer on 
bool Delay_Stop ; //Accensione modalità timer off 
bool Ora_Accens ; //Accensione startup a orario settato
bool Modo_Lavoro ; //0=Statico 1=Dinamico
bool Sbrinamento_Start ; //
bool Vent_Start ; //
bool Start_Stop ; //1=Start 0=Stop Macchina
int Delay_Start_hh ; //Ore timer ritardo di accensione
int Delay_Start_mm ; //Minuti timer ritardo di accensione
int Delay_Stop_hh ; //Ore timer ritardo di spegnimento
int Delay_Stop_mm ; //Minuti timer ritardo di spegnimento
int Ora_Accens_hh ; //Ore accensione
int Ora_Accens_mm ; //Minuti Spegnimento
int Statico_Temp ; //Temperatura impostabile con modo statico
int Statico_Um ; //umidità impostabile in modo statico
int Anno ; //
int Mese ; //
int Giorno ; //
int Ora ; //
int Minuti ; //
int Secondi ; //
int Temperatura_1 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_1 ; //Umidita da impostare nelle ricette (%)
int TempoH_1 ; //Tempo da impostare in ORE
int TempoM_1 ; //Tempo da impostare in MINUTI
int Temperatura_2 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_2 ; //Umidita da impostare nelle ricette (%)
int TempoH_2 ; //Tempo da impostare in ORE
int TempoM_2 ; //Tempo da impostare in MINUTI
int Temperatura_3 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_3 ; //Umidita da impostare nelle ricette (%)
int TempoH_3 ; //Tempo da impostare in ORE
int TempoM_3 ; //Tempo da impostare in MINUTI
int Temperatura_4 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_4 ; //Umidita da impostare nelle ricette (%)
int TempoH_4 ; //Tempo da impostare in ORE
int TempoM_4 ; //Tempo da impostare in MINUTI
int Temperatura_5 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_5 ; //Umidita da impostare nelle ricette (%)
int TempoH_5 ; //Tempo da impostare in ORE
int TempoM_5 ; //Tempo da impostare in MINUTI
int Temperatura_6 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_6 ; //Umidita da impostare nelle ricette (%)
int TempoH_6 ; //Tempo da impostare in ORE
int TempoM_6 ; //Tempo da impostare in MINUTI
int Temperatura_7 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_7 ; //Umidita da impostare nelle ricette (%)
int TempoH_7 ; //Tempo da impostare in ORE
int TempoM_7 ; //Tempo da impostare in MINUTI
int Temperatura_8 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_8 ; //Umidita da impostare nelle ricette (%)
int TempoH_8 ; //Tempo da impostare in ORE
int TempoM_8 ; //Tempo da impostare in MINUTI
int Temperatura_9 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_9 ; //Umidita da impostare nelle ricette (%)
int TempoH_9 ; //Tempo da impostare in ORE
int TempoM_9 ; //Tempo da impostare in MINUTI
int Temperatura_10 ; //Temperatura da impostare nelle ricette (°C)
int Umidita_10 ; //Umidita da impostare nelle ricette (%)
int TempoH_10 ; //Tempo da impostare in ORE
int TempoM_10 ; //Tempo da impostare in MINUTI
bool Abilita_Ricetta_1 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_2 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_3 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_4 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_5 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_6 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_7 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_8 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_9 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_10 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_11 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_12 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_13 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_14 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_15 ; //Bit che abilita quel passaggio nella ricetta
bool Abilita_Ricetta_16 ; //Bit che abilita quel passaggio nella ricetta
bool Alm_Term_Cmp ; //Termico compressore
bool Alm_Term_Vent1 ; //Termico ventola 
bool Alm_Term_Vent2 ; //Termico ventola 2
bool Alm_Term_Vent3 ; //Termico ventola 3
bool Alm_Term_Evp1 ; //Termico evaporatore 1
bool Alm_Term_Evp2 ; //Termico evaporatore 2
bool Alm_H_Cmp ; //Allarme alto compressore
bool Alm_L_Cmp ; //Allarme basso compressore
int Numero_ricetta ; //Numero della ricetta che sto modificando
bool Richiama_Ricetta ; //Bit che imposto a uno da hmi per richiamare la ricetta nell'hmi (Reset da PLC)
bool Salva_Ricetta ; //Bit che imposto a uno da hmi per salvare la ricetta sul PLC (Reset da PLC)

//----------------------------------